%define anolis_release 2

%global __provides_exclude_from %{?__provides_exclude_from:%__provides_exclude_from|}^%{_libexecdir}
%global __requires_exclude %{?__requires_exclude:%__requires_exclude|}^perl\\(ENVDumper\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(TempDir\\)
%global __requires_exclude %{__requires_exclude}|^perl\\(Carp::Foo\\)


Name:               perl-local-lib
Version:            2.000029
Release:            %{anolis_release}%{?dist}
License:            GPL+ or Artistic
Summary:            Create and use a local lib/ for perl modules with PERL5LIB
Url:                https://metacpan.org/release/local-lib
Source0:            https://cpan.metacpan.org/authors/id/H/HA/HAARG/local-lib-%{version}.tar.gz
Source1:            perl-homedir.sh
Source2:            perl-homedir.csh

BuildRequires:      coreutils make gcc gcc-c++ automake autoconf
BuildRequires:      perl-generators perl-interpreter
BuildRequires:      perl(CPAN) perl(CPAN::HandleConfig)
BuildRequires:      perl(ExtUtils::MakeMaker) >= 7.00
BuildRequires:      perl(File::HomeDir) perl(File::Spec)
BuildRequires:      perl(strict) perl(warnings) perl(Config)
BuildRequires:      perl(Carp) perl(Carp::Heavy) perl(Exporter) perl(lib)
BuildRequires:      perl(File::Basename) perl(File::Glob)
BuildRequires:      perl(base) perl(Cwd) perl(Data::Dumper)
BuildRequires:      perl(File::Path) perl(File::Spec::Functions) perl(File::Temp)
BuildRequires:      perl(IPC::Open3) perl(Test::More)
Requires:           perl(Carp) perl(Carp::Heavy)   
Requires:           perl(File::Basename) perl(File::Glob) perl(File::Spec)
BuildArch:          noarch


%description
This module provides a quick, convenient way of bootstrapping a user-local 
Perl module library located within the user's home directory. It also constructs 
and prints out for the user the list of environment variables using the syntax 
appropriate for the user's current shell (as specified by the SHELL environment 
variable), suitable for directly adding to one's shell configuration file.

More generally, local::lib allows for the bootstrapping and usage of a directory 
containing Perl modules outside of Perl's @INC. This makes it easier to ship 
an application with an app-specific copy of a Perl module, or collection of modules. 
Useful in cases like when an upstream maintainer hasn't applied a patch to a module 
of theirs that you need for your application.


%package -n perl-homedir
License:        GPL+ or Artistic
Summary:        Per-user Perl local::lib setup
Requires:       sed
Requires:       %{name} = %{version}-%{release}

%description -n perl-homedir
perl-homedir configures the system to automatically create a ~/perl5 directory 
in each user's $HOME on user login.  This allows each user to install CPAN packages 
via the CPAN to their $HOME, with no additional configuration or privileges, 
and without installing them system-wide.

%package tests
Summary:        Tests for %{name}
Requires:       %{name} = %{?epoch:%{epoch}:}%{version}-%{release}
Requires:       perl-Test-Harness

%description tests
This package contains tests from %{name}. Execute them with "%{_libexecdir}/%{name}/test".

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{EVR}
BuildArch:      noarch

%description    doc
The perl-local-lib-doc package contains documentation files for perl-local-lib.

%prep
%autosetup -n local-lib-%{version} -p1

for F in t/*.t; do
    %{__perl} -i -MConfig -ple 'print $Config{startperl} if $. == 1 && !s{\A#!.*perl\b}{$Config{startperl}}' "$F"
    chmod +x "$F"
done

%build
%{__perl} Makefile.PL INSTALLDIRS=vendor NO_PACKLIST=1 NO_PERLLOCAL=1
%make_build

%install
%make_install
%{_fixperms} %{buildroot}/*

mkdir -p %{buildroot}%{_sysconfdir}/profile.d
install -m 0644 -p %{SOURCE1} %{buildroot}%{_sysconfdir}/profile.d/
install -m 0644 -p %{SOURCE2} %{buildroot}%{_sysconfdir}/profile.d/

mkdir -p %{buildroot}%{_libexecdir}/%{name}
cp -a t %{buildroot}%{_libexecdir}/%{name}

cat > %{buildroot}%{_libexecdir}/%{name}/test << 'EOF'
#!/bin/sh
cd %{_libexecdir}/%{name} && exec prove -I . -r -j "$(getconf _NPROCESSORS_ONLN)"
EOF

chmod +x %{buildroot}%{_libexecdir}/%{name}/test


%check
export HARNESS_OPTIONS=j$(perl -e 'if ($ARGV[0] =~ /.*-j([0-9][0-9]*).*/) {print $1} else {print 1}' -- '%{?_smp_mflags}')
make test


%files
%{perl_vendorlib}/*
%{_mandir}/man3/*.zst

%files -n perl-homedir
%{_sysconfdir}/profile.d/*

%files tests
%{_libexecdir}/%{name}

%files doc
%doc Changes


%changelog
* Thu Apr 13 2023 chen_yu_ao <m15927509890@163.com> - 2.000029-2
- change spec file format

* Fri Feb 10 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.000029-1
- update to version 2.000029

* Fri Feb 03 2023 mgb01105731 <mgb01105731@alibaba-inc.com> - 2.000028-3
- remove versioned MODULE_COMPAT_ requires

* Mon Jan 30 2023 Chunmei Xu <xuchunmei@linux.alibaba.com> - 2.000028-2
- rebuild with perl 5.36.0

* Wed Apr 20 2022 zhang xianting <zhangxianting@uniontech.com> - 2.000028-1
- Initial build for Anolis V23
